
/********************************** (C) COPYRIGHT *******************************
* File Name          : SPI0Flash.C
* Author             : WCH
* Version            : V1.2
* Date               : 2016/1/15
* Description        : CH559 SPI0 дⲿFlash
*******************************************************************************/
#include ".\DEBUG.C"                                                          //Ϣӡ
#include ".\DEBUG.H"
#include "string.h"
#pragma  NOAREGS

#define THIS_ENDP0_SIZE         DEFAULT_ENDP0_SIZE
UINT8X  Ep0Buffer[THIS_ENDP0_SIZE] _at_ 0x0000;                                //˵0 OUT&INżַ
UINT8X  Ep1Buffer[2*MAX_PACKET_SIZE] _at_ 0x0008;                                //˵1 IN,żַ
UINT8   UsbConfig = 0; 

#define UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)

/*豸*/
UINT8C  MyDevDescr[] = { 0x12, 0x01, 0x10, 0x01,
                         0x00, 0x00, 0x00, THIS_ENDP0_SIZE,
                         0x44, 0x33, 0x33, 0x35,                              // IDͲƷID
                         0x00, 0x01, 0x01, 0x02,
                         0x00, 0x01
                       };
/**/
UINT8C  MyCfgDescr[] = { 0x09, 0x02, 0x20, 0x00, 0x01, 0x01, 0x00, 0x80, 0x32,
                         0x09, 0x04, 0x00, 0x00, 0x02, 0x08, 0x06, 0x50, 0x00,                     
                         0x07, 0x05, 0x01, 0x02, 0x40, 0x00, 0x00,
                         0x07, 0x05, 0x81, 0x02, 0x40, 0x00, 0x00
                       };
/**/
UINT8C  MyLangDescr[] = { 0x04, 0x03, 0x09, 0x04 };
/*Ϣ*/
UINT8C  MyManuInfo[] = { 0x0E, 0x03, 'w', 0, 'c', 0, 'h', 0, '.', 0, 'c', 0, 'n', 0 };
/*ƷϢ*/
UINT8C  MyProdInfo[] = { 0x0C, 0x03, 'C', 0, 'H', 0, '5', 0, '5', 0, '9', 0 };

UINT8C  MAX_LUN[] = {0};

//INQUIRY inform
UINT8C	DBINQUITY[]={
						0x00,             //Peripheral Device Type
						0x80, 			//
						0x02 ,			//ISO/ECMA
						0x02 ,			//
						0x1f ,			//Additional Length

						00 ,			//Reserved
						00 ,			//Reserved
						00 ,				//Reserved


					    'w' ,			//Vendor Information
						'c' ,			//
						'h' ,			//
						'.' ,			//
						'c' ,			//
						'n' ,			//
						' ' ,			//
						' ' ,			//


        			    0xc7,			//Product Identification
						0xdf, 			//
						0xba,			//
						0xe3,			//
						0xb5,			//
						0xe7,			//
						0xd7,			//
						0xd3,			//
						0x55,			//
						0xc5,			//
						0xcc,			//
						0xb7,			//
						0xbd,			//
						0xb0,			//
						0xb8,			//
						0x00,          //

               			'1' ,			//Product Revision Level
						'.' ,			//
						'1' ,			//
						'0'  			//
						  };

//޸ĺ㶨ʱע޸ĲǰΪ4kҪӦ޸ɡ
						  
#define DISK_SEC_NUM   0x00000200       //  512
#define DISK_SEC_LAST  DISK_SEC_NUM- 1  //һ߼ַ				  
#define DISK_SEC_LEN   0x00001000       //С  ÿ4096ֽڴС
						  					  
						  
UINT8C DBCAPACITY[]={ (DISK_SEC_LAST>>24)&0xFF, (DISK_SEC_LAST>>16)&0xFF, (DISK_SEC_LAST>>8)&0xFF, DISK_SEC_LAST&0xFF , (DISK_SEC_LEN>>24)&0xFF, (DISK_SEC_LEN>>16)&0xFF, (DISK_SEC_LEN>>8)&0xFF, DISK_SEC_LEN&0xFF};    //last logic addr//block lenth

UINT8C  modesense3F[]={
				0x0b, 0x00, 0x00, 0x08, (DISK_SEC_NUM>>24)&0xFF, (DISK_SEC_NUM>>16)&0xFF, (DISK_SEC_NUM>>8)&0xFF, DISK_SEC_NUM&0xFF, 00, 00, 02, 00 };   //

UINT8C  mode5sense3F[]={
				0x00, 0x06, 0x00, 0x00, 0x08, 0x00, 0x00, 0x08,(DISK_SEC_NUM>>24)&0xFF, (DISK_SEC_NUM>>16)&0xFF, (DISK_SEC_NUM>>8)&0xFF, DISK_SEC_NUM&0xFF, 00, 00, 02, 00 };  //


sbit CHIP_SELECT = P1^4;
#define SENDBYTE_SPI( d )    {  SPI0_DATA = d;while(S0_FREE == 0); }
#define RECVBYTE_SPI( d )    { SPI0_DATA = 0xff;while(S0_FREE == 0);d = SPI0_DATA;}

UINT8 buffer[64]; 

typedef union _CBWCB{
		unsigned char buf1[16];
}CBWCB;

typedef  union _MASS_PARA {
		unsigned char buf[64];
		struct  _SENSE{
			unsigned char ErrorCode;
			unsigned char Reserved1;
			unsigned char SenseKey;
			unsigned char Information[4];
			unsigned char AddSenseLength;
			unsigned char Reserved2[4];
			unsigned char AddSenseCode;
			unsigned char AddSenseCodeQua;
			unsigned char Reserved3[4];
		}Sense;
	//	unsigned char SenseData[18];
		struct  _CBW{
		unsigned char dCBWsig[4];
		unsigned char dCBWTag[4];
		unsigned long dCBWDatL;
		unsigned char bmCBWFlags;
		unsigned char bCBWLUN;
		unsigned char bCBWCBLength;
		CBWCB        cbwcb;
	}cbw;
		struct _CSW{

		unsigned char buf2[13];
	}csw;


}MASS_PARA;

enum _HOST_DEV_DISAGREE {
CASEOK = 0,
CASE1,
CASE2,
CASE3,
CASE4,
CASE5,
CASE6,
CASE7,
CASE8,
CASE9,
CASE10,
CASE11,
CASE12,
CASE13,
CASECBW,
CASECMDFAIL
};

#define FORMAT_UNIT 	0x04
#define INQUIRY 		0x12
#define MODE_SELECT 	0x15
#define MODE_SENSE5 	0x5A
#define MODE_SENSE 		0x1A
#define PER_RES_IN 		0x5E
#define PER_RES_OUT 	0x5F
#define PRE_OR_MED 		0x1E
#define READ 			0x28
#define READ_CAPACITY 	0x25
#define RELEASE 		0x17
#define REQUEST_SENSE 	0x03
#define RESERVE 		0x16
#define STA_STO_UNIT 	0x1B
#define SYN_CACHE 		0x35
#define TES_UNIT 		0x00
#define VERIFY 			0x2F
#define WRITE 			0x2A
#define WRITE_BUFFER 	0x3B


union {
unsigned long mDataLength;							//ݳ
unsigned char mdataLen[4];							//
} LEN;


unsigned char mdCBWTag[4];						//dCBWTag
MASS_PARA  MassPara;
bit CH375BULKUP;									//ϴ
bit CH375BULKDOWN;									//´
bit CH375CSW;										//CSWϴ־
unsigned char	BcswStatus;							//CSW״̬
unsigned char mSenseKey;
unsigned char mASC;
bit FSTALL;											//ݴ־
bit lastFSTALL;
bit pBuf_ReSelect = 0;

UINT32 Locate_Addr;

unsigned char *pBuf;

/*******************************************************************************
* Function Name  : USBDeviceCfg()
* Description    : USB豸ģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    InitUSB_Device( void )                                                      // ʼUSB豸
{
    IE_USB = 0;
    USB_CTRL = 0x00;                                                                // 趨ģʽ
    UEP4_1_MOD = bUEP1_TX_EN | bUEP1_RX_EN;                                         // ˵1շģʽ
    UEP0_DMA = Ep0Buffer;
    UEP1_DMA = Ep1Buffer;
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
    UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
    USB_DEV_AD = 0x00;
    UDEV_CTRL = bUD_DP_PD_DIS | bUD_DM_PD_DIS;                                      // ֹDP/DM
    USB_CTRL = bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;                           // USB豸DMAжڼжϱ־δǰԶNAK
    UDEV_CTRL |= bUD_PORT_EN;                                                       // USB˿
    USB_INT_FG = 0xFF;                                                              // жϱ־
    USB_INT_EN = bUIE_SUSPEND | bUIE_TRANSFER | bUIE_BUS_RST;
    IE_USB = 1;
	UEP1_T_LEN = 0;                                                       //Ԥʹ÷ͳһҪ 
	
	EA = 1;
}


/*******************************************************************************
* Function Name  : InitHostSPI0( void )
* Description    : SPI0ģʽʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void    InitHostSPI0( void )
{
    SPI0_SETUP &=~(bS0_MODE_SLV | bS0_BIT_ORDER);                              /*óģʽ*/
    SPI0_CTRL = bS0_SCK_OE | bS0_MOSI_OE;                                      /*дĬϲд䣬ʹbS0_DATA_DIR*/
                                                                               /*ôݺԶһֽڵʱӣڿշ*/
    P1_DIR |= (bMOSI | bSCK | bSCS| bPWM3 );                                   /*bMOSI bSCK bSCSΪ*/
    P1_DIR &= ~bMISO;
    SPI0_CK_SE = 0x02; //0x02                                                        /*ƵΪ12M*/
//  SPI0_STAT = 0xFF;                                                          /*жϱ־*/
//  IE_SPI0 = 1;
}

/*******************************************************************************
* Function Name  : ReadExternalFlashStatusReg_SPI
* Description    : ȡ״̬Ĵ,״̬Ĵֵ
* Input          : None
* Output         : None
* Return         : ExFlashRegStatus
*******************************************************************************/
UINT8 ReadExternalFlashStatusReg_SPI( void )
{
    UINT8 ExFlashRegStatus;
    CHIP_SELECT = 0;
    SENDBYTE_SPI(0x05);                                                        /*Ͷ״̬Ĵ */
    RECVBYTE_SPI(ExFlashRegStatus);                                            /*ȡ״̬Ĵ*/
    CHIP_SELECT = 1 ;
    return ExFlashRegStatus;
}
   
/*******************************************************************************
* Function Name  : WaitExternalFlashIfBusy
* Description    : ȴоƬ(ִByte-Program, Sector-Erase, Block-Erase, Chip-Erase)
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WaitExternalFlashIfBusy( void )
{
    while ((ReadExternalFlashStatusReg_SPI())&0x01 == 0x01 )                   /*ȴֱFlash*/
    {
        ReadExternalFlashStatusReg_SPI( );
    }
}

/*******************************************************************************
* Function Name  : WriteExternalFlashStatusReg_SPI
* Description    : ״̬Ĵдһֽ
* Input          : status -д
* Output         : None
* Return         : None
*******************************************************************************/
void WriteExternalFlashStatusReg_SPI( UINT8 status )
{
    CHIP_SELECT = 0 ;
    SENDBYTE_SPI(0x01);                                                       /*д״̬Ĵ*/
    SENDBYTE_SPI(status);                                                     /*ıĴBPxBPL (ֻ2,3,4,5,7λԸд)*/
    CHIP_SELECT = 1 ;
}
 /*********************************************************
*  static void st25vf016b_WRDI(void)
*ܣдֹ
*    
*ֵ                                                                                                      
***************************************************************/
void WriteFlashForbidden(void)
{
	CHIP_SELECT = 0 ;
	SENDBYTE_SPI(0x04);
	CHIP_SELECT = 1 ;   
}
/*******************************************************************************
* Function Name  : WriteExternalFlashEnable_SPI
* Description    : дʹ,ͬʹд״̬Ĵ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void WriteExternalFlashEnable_SPI( void )
{
    CHIP_SELECT = 0 ;
    SENDBYTE_SPI(0x06);                                                       /*дʹ*/
    CHIP_SELECT = 1 ;
}

/*******************************************************************************
* Function Name  : CheckExternalFlashWriteEnable_SPI
* Description    : дǰWELλǷΪ1
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CheckExternalFlashWriteEnable_SPI( void )
{
    UINT8 WRENStatus;
    WRENStatus = ReadExternalFlashStatusReg_SPI();                            /*ȡ״̬register*/
    if ((WRENStatus&0x02) != 0x02)                                            /*WELλλ*/
    {
        WriteExternalFlashEnable_SPI( );                                      /*δ1Ӧ,дʹܲ*/
    }
}

/*******************************************************************************
* Function Name  : EraseExternalFlash_SPI
* Description    : 4K Flash  һ
* Input          : Dst_Addr 0-1 ffff ffff ,ַڵ
* Output         : None
* Return         : None
*******************************************************************************/
void EraseExternalFlash_SPI( UINT32 Dst_Addr )
{
//	WriteExternalFlashStatusReg_SPI( 0x00 ); //оƬΪޱ
//	WriteExternalFlashEnable_SPI();//дʹ
    CheckExternalFlashWriteEnable_SPI();
    CHIP_SELECT = 0 ;
    SENDBYTE_SPI(0x20);    //         //0x60Ƭ0x20һ
    SENDBYTE_SPI(((Dst_Addr & 0xFFFFFF) >> 16));                                //send 3 address bytes  
    SENDBYTE_SPI(((Dst_Addr & 0xFFFF) >> 8));
    SENDBYTE_SPI(Dst_Addr & 0xFF);	
	
    CHIP_SELECT = 1 ;
    WaitExternalFlashIfBusy();
}

/*******************************************************************************
* Function Name  : ByteReadExternalFlash_SPI
* Description    : ȡһַһֽڵ.ضȡ 
* Input          : UINT32 StarAddr -Destination Address 000000H - 1FFFFFH
* Output         : None
* Return         : byte -ȡ
*******************************************************************************/
UINT8 ByteReadExternalFlash_SPI(UINT32 StarAddr)    
{   
    UINT8 dat = 0;    
    CHIP_SELECT = 0 ;                                                           //enable device  
    SENDBYTE_SPI(0x03);                                                         //read command 
    SENDBYTE_SPI(((StarAddr & 0xFFFFFF) >> 16));                                //send 3 address bytes  
    SENDBYTE_SPI(((StarAddr & 0xFFFF) >> 8));
    SENDBYTE_SPI(StarAddr & 0xFF);
    RECVBYTE_SPI(dat);   
    CHIP_SELECT = 1 ;                                                           //disable device   
    return dat;                                                                 //return one byte read
} 

/*******************************************************************************
* Function Name  : ByteWriteExternalFlash_SPI
* Description    : д
* Input          : StarAddr  -Destination Address 000000H - 1FFFFFH
*                  dat -Ҫд
* Output         : None
* Return         : None
*******************************************************************************/
void ByteWriteExternalFlash_SPI(UINT32 StarAddr, UINT8 dat)
{
    WriteExternalFlashEnable_SPI();
    CHIP_SELECT = 0 ;                                                          //оƬʹ 
    SENDBYTE_SPI(0x02);                                                        //дָ 
    SENDBYTE_SPI(((StarAddr & 0xFFFFFF) >> 16));                                    //3ֽڵַ 
    SENDBYTE_SPI(((StarAddr & 0xFFFF) >> 8));
    SENDBYTE_SPI(StarAddr & 0xFF);
    SENDBYTE_SPI(dat);                                                         //Ҫд
    CHIP_SELECT = 1 ;
    WaitExternalFlashIfBusy();
}

/*******************************************************************************
* Function Name  : BlukReadExternalFlash_SPI
* Description    : ȡʼַ(StarAddr)ڶֽ(Len).뻺RcvBuffer
* Input          : StarAddr -Destination Address 000000H - 1FFFFFH
                   Len ȡݳ
                   RcvBuffer ջʼַ
* Output         : None
* Return         : None
*******************************************************************************/
void BlukReadExternalFlash_SPI(UINT32 StarAddr,UINT16 Len,PUINT8 RcvBuffer)
{
	UINT16 i;	
    CHIP_SELECT = 0 ;                                                           //enable device  
    SENDBYTE_SPI(0x0b);                                                         //read command 
    SENDBYTE_SPI(((StarAddr & 0xFFFFFF) >> 16));                                //send 3 address bytes  
    SENDBYTE_SPI(((StarAddr & 0xFFFF) >> 8));
    SENDBYTE_SPI(StarAddr & 0xFF);
	SENDBYTE_SPI(0x00);
	for(i=0; i<Len; i++)                                                        /**/
    {
		RECVBYTE_SPI(RcvBuffer[i]);                                                            /*ȡһַ*/
    }
    CHIP_SELECT = 1 ;                                                           //disable device   
}

/*******************************************************************************
* Function Name  : BlukWriteExternalFlash_SPI
* Description    : дⲿFlash
* Input          : StarAddr  -Destination Address 000000H - 1FFFFFH
                   Len ݳ
*                  SendBuffer -ݻ
* Output         : None
* Return         : None
*******************************************************************************/
void BlukWriteExternalFlash_SPI(UINT32 StarAddr,UINT16 Len,PUINT8 SendBuffer)
{
	unsigned int timeout = 0;
	unsigned int i = 0;
	
    WriteExternalFlashStatusReg_SPI( 0x00 ); //оƬΪޱ
	WriteExternalFlashEnable_SPI();//дʹ
	
	CHIP_SELECT = 0 ;
	SENDBYTE_SPI(0xad);             //Զַ(2byte)ģʽ
	
    SENDBYTE_SPI(((StarAddr & 0xFFFFFF) >> 16));                                    //3ֽڵַ 
    SENDBYTE_SPI(((StarAddr & 0xFFFF) >> 8));
    SENDBYTE_SPI(StarAddr & 0xFF);
	
	SENDBYTE_SPI(SendBuffer[i]);
	SENDBYTE_SPI(SendBuffer[i+1]);	
	CHIP_SELECT = 1 ; 	
	
	WaitExternalFlashIfBusy();	  //ȴֱ

	for(i = 2; i < Len-1; i++)
	{
		CHIP_SELECT = 0 ;
		SENDBYTE_SPI(0xad); //Զַ(2byte)ģʽ
		SENDBYTE_SPI(SendBuffer[i++]);
	    SENDBYTE_SPI(SendBuffer[i]);	
	    CHIP_SELECT = 1 ;
		
		WaitExternalFlashIfBusy();	  //ȴֱ
    }	
	
	WriteFlashForbidden();//дֹ
	WaitExternalFlashIfBusy();	  //ȴֱ
	
	
}

void main( ) 
{
    mDelaymS(30);                                                                  //ϵʱ,ȴڲȶ,ؼ 
    mInitSTDIO( );                                                                 /* Ϊüͨڼʾ */
    printf( "Start SPI FLASH @ChipID=%02X\n", (UINT16)CHIP_ID );

    InitHostSPI0( );
    WriteExternalFlashEnable_SPI( );                                               //FLASHдʹ
    WriteExternalFlashStatusReg_SPI( 0x00 );                                       //дĴ 
	
	InitUSB_Device();
	
	while(1);
}

//BLOCK ONLY  The Thirteen Cases

void  BulkThirteen(unsigned char Case)
{
	switch(Case)
	{
	case CASEOK:
	case CASE1:     									/* Hn=Dn*/
	case CASE6:     									/* Hi=Di*/
		BcswStatus = 0;
		break;
	case CASE12:    									/* Ho=Do*/
		BcswStatus = 0;
		break;

	case CASE2:     									/* Hn<Di*/
	case CASE3:     									/* Hn<Do*/

		UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
		FSTALL=1;
														//ϴ˵һSTALL // may or may-not
		BcswStatus =2;
		break;

	case CASE4:     									/* Hi>Dn*/
	case CASE5:     									/* Hi>Di*/


		UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
		FSTALL=1;
														//ϴ˵һSTALL
		BcswStatus= 1;									//CSW_GOOD or CSW_FAIL
		break;


	case CASE7:    										 /* Hi<Di*/
	case CASE8:     									/* Hi<>Do */

		UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
			FSTALL=1;
													//ϴ˵һSTALL
		BcswStatus = 2;
		break;

	case CASE9:     										/* Ho>Dn*/
	case CASE11:    									/* Ho>Do*/

		UEP1_CTRL = UEP1_CTRL | MASK_UEP_R_RES ;
		FSTALL=1;
													//ϴ˵һSTALL
	BcswStatus =1;									//CSW_GOOD or CSW_FAIL
		break;

	case CASE10:    								/* Ho<>Di */
	case CASE13:    								/* Ho<Do*/

		UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
		FSTALL=1;
													//ϴ˵һSTALL
		UEP1_CTRL = UEP1_CTRL | MASK_UEP_R_RES ;
													//ϴ˵һSTALL
		BcswStatus = 2;
		break;

	case CASECBW:   								/* invalid CBW */

	    UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
		FSTALL=1;
		UEP1_CTRL = UEP1_CTRL | MASK_UEP_R_RES ;
											//˵һSTALL
		BcswStatus = 2;
		break;

	case CASECMDFAIL:

		UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
		FSTALL=1;
												//ϴ˵һSTALL
		BcswStatus= 1;
		break;

	default:
		break;
	}
}



				
void  UFI_readCapacity(void ){
	
		if ( LEN.mDataLength > sizeof(DBCAPACITY) ) LEN.mDataLength = sizeof(DBCAPACITY);
		pBuf=(unsigned char*)DBCAPACITY;	
		BcswStatus=0;
		mSenseKey=0;
		mASC=0;
}

void  UFI_inquiry(void ){
		pBuf = DBINQUITY;					////ѯUϢ
		if(LEN.mDataLength>36) LEN.mDataLength=36;
		BcswStatus=0;
		mSenseKey=0;
		mASC=0;
	
}
void  UFI_read10(void){
													//ȡ
		LEN.mDataLength=(((UINT32)MassPara.cbw.cbwcb.buf1[7]<<8) | (UINT32)MassPara.cbw.cbwcb.buf1[8])*DISK_SEC_LEN;
		Locate_Addr = ((UINT32)MassPara.cbw.cbwcb.buf1[2]<<24) | ((UINT32)MassPara.cbw.cbwcb.buf1[3]<<16) | ((UINT32)MassPara.cbw.cbwcb.buf1[4]<<8) | (UINT32)MassPara.cbw.cbwcb.buf1[5];
	
		Locate_Addr = Locate_Addr*DISK_SEC_LEN;
	
	//	printf("Read addr:%ld  len:%ld \n",Locate_Addr,LEN.mDataLength);
	
		BcswStatus=0;
		mSenseKey=0;
		mASC=0;
	
		pBuf_ReSelect = 1;

}

void  UFI_modeSense(void ){
										//ģʽʶ
		if(MassPara.cbw.cbwcb.buf1[2]==0x3F){
			if ( LEN.mDataLength > sizeof(modesense3F) ) LEN.mDataLength = sizeof(modesense3F);
			pBuf=modesense3F;
			BcswStatus=0;
			mSenseKey=0;
			mASC=0;
		}
		else {
			CH375BULKUP=0;
			mSenseKey=5;
			mASC=0x20;

			BcswStatus=1;
			BulkThirteen(CASECMDFAIL);
	   	}
}

void  UFI_requestSense(void ){
											//ʶ
	if ( FSTALL | lastFSTALL ) {
		lastFSTALL=FSTALL;
		FSTALL=0;
		MassPara.Sense.ErrorCode=0x70;
		MassPara.Sense.Reserved1=0;
		MassPara.Sense.SenseKey=mSenseKey;
		MassPara.Sense.Information[0]=0;
		MassPara.Sense.Information[1]=0;
		MassPara.Sense.Information[2]=0;
		MassPara.Sense.Information[3]=0;
		MassPara.Sense.AddSenseLength=0x0a;
		MassPara.Sense.Reserved2[0]=0;
		MassPara.Sense.Reserved2[1]=0;
		MassPara.Sense.Reserved2[2]=0;
		MassPara.Sense.Reserved2[3]=0;
		MassPara.Sense.AddSenseCode=mASC;
		MassPara.Sense.AddSenseCodeQua=00;
		MassPara.Sense.Reserved3[0]=0;
		MassPara.Sense.Reserved3[1]=0;
		MassPara.Sense.Reserved3[2]=0;
		MassPara.Sense.Reserved3[3]=0;
		pBuf=MassPara.buf;
		BcswStatus=0;
	}
	else {
		lastFSTALL=FSTALL;
		FSTALL=0;
		MassPara.Sense.ErrorCode=0x70;
		MassPara.Sense.Reserved1=0;
		MassPara.Sense.SenseKey=0x00;
		MassPara.Sense.Information[0]=0;
		MassPara.Sense.Information[1]=0;
		MassPara.Sense.Information[2]=0;
		MassPara.Sense.Information[3]=0;
		MassPara.Sense.AddSenseLength=0x0a;
		MassPara.Sense.Reserved2[0]=0;
		MassPara.Sense.Reserved2[1]=0;
		MassPara.Sense.Reserved2[2]=0;
		MassPara.Sense.Reserved2[3]=0;
		MassPara.Sense.AddSenseCode=0x00;
		MassPara.Sense.AddSenseCodeQua=00;
		MassPara.Sense.Reserved3[0]=0;
		MassPara.Sense.Reserved3[1]=0;
		MassPara.Sense.Reserved3[2]=0;
		MassPara.Sense.Reserved3[3]=0;
		pBuf=MassPara.buf;
		BcswStatus=0;
	}
}
void  UFI_testUnit(void ){
		CH375BULKDOWN=0;
		CH375BULKUP=0;
		BcswStatus=0;			//UǷ׼
		mSenseKey=0;
		mASC=0;
}
void  UFI_perOrMed(void ){				//Ƴ
		BcswStatus=0;
		mSenseKey=0;
		mASC=0;
}
void  UFI_write(void ){
		UINT8 i,num;
		LEN.mDataLength=(((UINT32)MassPara.cbw.cbwcb.buf1[7]<<8) | (UINT32)MassPara.cbw.cbwcb.buf1[8])*DISK_SEC_LEN;		//дݳ
		Locate_Addr = ((UINT32)MassPara.cbw.cbwcb.buf1[2]<<24) | ((UINT32)MassPara.cbw.cbwcb.buf1[3]<<16) | ((UINT32)MassPara.cbw.cbwcb.buf1[4]<<8) | (UINT32)MassPara.cbw.cbwcb.buf1[5];
		Locate_Addr = Locate_Addr*DISK_SEC_LEN;
	//
		num = MassPara.cbw.cbwcb.buf1[8];   //д
		for(i=0;i<num;i++)
			EraseExternalFlash_SPI(Locate_Addr + i*DISK_SEC_LEN);  

		BcswStatus=0;
		mSenseKey=0;
		mASC=0;
	
}
void  UFI_staStoUnit(void ){     //װж豸
		CH375BULKDOWN=0;
		CH375BULKUP=0;
		BcswStatus=0;
			mSenseKey=0;
			mASC=0;
}
void  UFI_verify(void ){
		BcswStatus=0;		//У洢ռ
		mSenseKey=0;
		mASC=0;
					//ֻΪʾû洢
					//ʵһһҪ
}
void  UFI_modeSense5(void ){

		if(MassPara.cbw.cbwcb.buf1[2]==0x3F){
			if ( LEN.mDataLength > sizeof(mode5sense3F) ) LEN.mDataLength = sizeof(mode5sense3F);
			pBuf=mode5sense3F;
			BcswStatus=0;
			mSenseKey=0;
			mASC=0;
		}
		else {
			CH375BULKUP=0;
			mSenseKey=5;
			mASC=0x20;
			BcswStatus=1;
			BulkThirteen(CASECMDFAIL);
	   	}
}
//UFI  CMD
void UFI_Hunding(void ){		
		switch(MassPara.cbw.cbwcb.buf1[0]){
			case INQUIRY:
				UFI_inquiry();
			break;
			case WRITE:
				
				//printf("%2x\n",(UINT16)MassPara.cbw.cbwcb.buf1[0]);			
               UFI_write();
			break;
			case TES_UNIT:
				UFI_testUnit();
			break;
			case READ:
				UFI_read10();
			break;
			case REQUEST_SENSE:
				UFI_requestSense();
			break;
			case READ_CAPACITY:
                UFI_readCapacity();
			break;
			case VERIFY:
				UFI_verify();
				break;
//		//	case 0x23:

//		//	break;
//		//	case MODE_SELECT:
//			//	UFI_modeSlect();
//		//	break;
			case MODE_SENSE:
				UFI_modeSense();
			break;
			case MODE_SENSE5:
				UFI_modeSense5();
			break;
//		//	case WRITE_BUFFER:
//		//		UFI_writeBuf();
//	//		break;
//	//		case PREVENT:
//		//	break;
//	//		case FORMAT_UNIT:
//		//		UFI_format();
//	//		break;
//	//		case RELEASE:
//	//		break;
			case STA_STO_UNIT:
				UFI_staStoUnit();
			break;
			case PRE_OR_MED:
				UFI_perOrMed();
			break;
			default:
				
			//printf("%2x\n",(UINT16)MassPara.cbw.cbwcb.buf1[0]);
			
				mSenseKey=5;
				mASC=0x20;
				BcswStatus=1;
				CH375BULKUP=0;
				BulkThirteen(CASECBW);
				break;
			}
}

void mCH375BulkOnly(){
			if(MassPara.buf[0]==0x55){
				if(MassPara.buf[1]==0x53){
				   if(MassPara.buf[2]==0x42){
				    	if(MassPara.buf[3]==0x43){
//							LEN.mDataLength=BIG_ENDIAN(MassPara.cbw.dCBWDatL);			//BOЭ鴦
							LEN.mdataLen[3] = *(unsigned char *)(&MassPara.cbw.dCBWDatL);  /* PCĵֽǰ16λתΪC51ĸֽǰ */
							LEN.mdataLen[2] = *( (unsigned char *)(&MassPara.cbw.dCBWDatL) + 1 );
							LEN.mdataLen[1] = *( (unsigned char *)(&MassPara.cbw.dCBWDatL) + 2 );
							LEN.mdataLen[0] = *( (unsigned char *)(&MassPara.cbw.dCBWDatL) + 3 );
							mdCBWTag[0]=MassPara.buf[4];
                             mdCBWTag[1]=MassPara.buf[5];
                              mdCBWTag[2]=MassPara.buf[6];
	                          mdCBWTag[3]=MassPara.buf[7];													  //ȡݳ
							if(LEN.mDataLength){
									CH375BULKDOWN=(MassPara.cbw.bmCBWFlags&0X80)?0:1;	//жϴ´
									CH375BULKUP=(MassPara.cbw.bmCBWFlags&0X80)?1:0;
								}
						  // if(!CBWLUN){      		//ֻ֧һ
								CH375CSW=1;
								UFI_Hunding();
							//UFIЭ鴦
						//	}
							//	else ;//˴Ӧ
					   }
						else
						UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
				  }
				   else
					UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
			     }
				else
				UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
			 }
			else
			UEP1_CTRL = UEP1_CTRL | MASK_UEP_T_RES ;
}

void mCH375UpCsw()
{
		unsigned char i;													//Ϊ0
		pBuf=&MassPara.buf[0];
		CH375CSW=0;																	//ϴCSW
		CH375BULKUP=0;														//ȡϴ
		MassPara.buf[0]=0x55;												//dCSWSignature
		MassPara.buf[1]=0x53;
		MassPara.buf[2]=0x42;
		MassPara.buf[3]=0x53;
		MassPara.buf[4]=mdCBWTag[0];
		MassPara.buf[5]=mdCBWTag[1];
		MassPara.buf[6]=mdCBWTag[2];
		MassPara.buf[7]=mdCBWTag[3];
		MassPara.buf[8]=0;
		MassPara.buf[9]=0;
		MassPara.buf[10]=LEN.mdataLen[1];
		MassPara.buf[11]=LEN.mdataLen[0];
		MassPara.buf[12]=BcswStatus;
		for(i = 0;i<13;i++)
		{
			Ep1Buffer[MAX_PACKET_SIZE+i] = *pBuf;
			pBuf++;
		}
		UEP1_T_LEN = 13;
		UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;  // ϴ
}

//**********************************************************************************
void CH375bulkUpData(){											//ö˵2ϴ
		unsigned char len,i;
		if(LEN.mDataLength>0x40){
			len=0x40;
			LEN.mDataLength-=0x40;
		}
		else {
			len= (unsigned char) LEN.mDataLength;
			LEN.mDataLength=0;
			CH375BULKUP=0;
		}
		
		if(pBuf_ReSelect)
		{
			BlukReadExternalFlash_SPI(Locate_Addr,len,&Ep1Buffer[MAX_PACKET_SIZE]);
			Locate_Addr += len;		
			if(LEN.mDataLength==0)
				pBuf_ReSelect = 0;
		}
		else
		{
			for(i = 0;i<len;i++)
			{
				Ep1Buffer[MAX_PACKET_SIZE+i] = *pBuf;
				pBuf++;
			}
		}
		UEP1_T_LEN = len;
		UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_ACK;  // ϴ
}


void mCH375BulkDownData(){
		unsigned char len,i;
	
		len = USB_RX_LEN;																								
		for(i=0;i!=len;i++)						
			buffer[i]=Ep1Buffer[i];	//ݶ뵽
	
		BlukWriteExternalFlash_SPI(Locate_Addr,len,&buffer[0]);
		Locate_Addr += len;
	
		LEN.mDataLength-=len;				//ȫݳȼǰõĳ

		if(LEN.mDataLength==0){														//Ϊ0,CSW
			CH375BULKDOWN=0;
			mCH375UpCsw();				//ϴCSW
	}
}

/*******************************************************************************
* Function Name  : USB_DeviceInterrupt()
* Description    : CH559USBģжϴ
*******************************************************************************/
void    USB_DeviceInterrupt( void ) interrupt INT_NO_USB using 1               /* USBжϷ,ʹüĴ1 */
{
    UINT8   len,length;
    static  UINT8   SetupReqCode, SetupLen;
    static  PUINT8  pDescr;
	
    if ( UIF_TRANSFER )                                                        // USB
    {
        if ( U_IS_NAK )                                                        // not enable for this example
        {
//          switch ( USB_INT_ST & ( MASK_UIS_TOKEN | MASK_UIS_ENDP ) )         // ƺͶ˵
//          {  
//              case UIS_TOKEN_OUT | 2:                                        // endpoint 2# ˵´
//                  break;
//              case UIS_TOKEN_IN | 2:                                         // endpoint 2# ˵ϴ
//                  break;
//              case UIS_TOKEN_IN | 1:                                         // endpoint 1# ж϶˵ϴ
//                  break;
//              default:
//                  break;
//          }
            printf("NAK INT,PrepareData\n");
        }
        else
        {
            switch ( USB_INT_ST & ( MASK_UIS_TOKEN | MASK_UIS_ENDP ) )         // ƺͶ˵
            {
            case UIS_TOKEN_IN | 1:                                             // endpoint 1# ж϶˵ϴ
				if(CH375BULKUP) CH375bulkUpData();								//ϴ
				else if(CH375CSW) mCH375UpCsw();									//ϴCSW
				else
                UEP1_CTRL = UEP1_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;      // ͣϴ
                break;
			case UIS_TOKEN_OUT | 1:
                if ( U_TOG_OK )                                                // ͬݰ
                {
					if(CH375BULKDOWN)  mCH375BulkDownData();									//ϴݽ׶ϴ
					else{	 										//´жǷ
							length = USB_RX_LEN;
							if(!length)break;								//ݰΪ																		
							for(len=0;len!=length;len++)						
								MassPara.buf[len]=Ep1Buffer[len];	//ݶ뵽

							mCH375BulkOnly();

							if(!CH375BULKDOWN){
								if(CH375BULKUP) CH375bulkUpData();					//ϴ
								else if(!FSTALL) mCH375UpCsw();								//ûϴCSWϴ
																				//ϴݵ
							}
					}	
                }				
			
				break;
            case UIS_TOKEN_SETUP | 0:                                          // endpoint 0# SETUP
                len = USB_RX_LEN;
                if ( len == sizeof( USB_SETUP_REQ ) )                          // SETUP
                {
                    SetupLen = UsbSetupBuf->wLengthL;
                    if ( UsbSetupBuf->wLengthH || SetupLen > 0x7F )
                    {
                        SetupLen = 0x7F;                                       // ܳ
                    }
                    len = 0;                                                   // ĬΪɹϴ0
                    if ( ( UsbSetupBuf->bRequestType & USB_REQ_TYP_MASK ) != USB_REQ_TYP_STANDARD )/*  */
                    {                                                                  
                        SetupReqCode = UsbSetupBuf->bRequest;
						if(SetupReqCode == 0xFE)   //GET MAX LUN
						{
							pDescr = (PUINT8)( &MAX_LUN[0] ); 							
							len = 1;
						    if ( SetupLen > len )
                            {
                                SetupLen = len;                                 // ܳ
                            }
                            len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;  // δ䳤
                            memcpy( Ep0Buffer, pDescr, len );                   /* ϴ */
                            SetupLen -= len;
                            pDescr += len;
							
						}
						
                    }
                    else                                                       // ׼
                    {
                        SetupReqCode = UsbSetupBuf->bRequest;
                        switch( SetupReqCode )                                 // 
                        {
                        case USB_GET_DESCRIPTOR:
                            switch( UsbSetupBuf->wValueH )
                            {
                            case 1:                                            // 豸
                                pDescr = (PUINT8)( &MyDevDescr[0] );
                                len = sizeof( MyDevDescr );
                                break;
                            case 2:                                            // 
                                pDescr = (PUINT8)( &MyCfgDescr[0] );
                                len = sizeof( MyCfgDescr );
                                break;
                            case 3:                                            // ַ
                                switch( UsbSetupBuf->wValueL )
                                {
                                case 1:
                                    pDescr = (PUINT8)( &MyManuInfo[0] );       
                                    len = sizeof( MyManuInfo );
                                    break;
                                case 2:
                                    pDescr = (PUINT8)( &MyProdInfo[0] );        
                                    len = sizeof( MyProdInfo );
                                    break;
                                case 0:
                                    pDescr = (PUINT8)( &MyLangDescr[0] );
                                    len = sizeof( MyLangDescr );
                                    break;
                                default:
                                    len = 0xFF;                                 // ֵַ֧
                                    break;
                                }
                                break;
                            default:
                                len = 0xFF;                                     // ֵ֧
                                break;
                            }
                            if ( SetupLen > len )
                            {
                                SetupLen = len;                                 // ܳ
                            }
                            len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen;  // δ䳤
                            memcpy( Ep0Buffer, pDescr, len );                   /* ϴ */
                            SetupLen -= len;
                            pDescr += len;
                            break;
                        case USB_SET_ADDRESS:
                            SetupLen = UsbSetupBuf->wValueL;                    // ݴUSB豸ַ
                            break;
                        case USB_GET_CONFIGURATION:
                            Ep0Buffer[0] = UsbConfig;
                            if ( SetupLen >= 1 )
                            {
                                len = 1;
                            }
                            break;
                        case USB_SET_CONFIGURATION:
                            UsbConfig = UsbSetupBuf->wValueL;
						
							printf("Config\n");
                            if ( UsbConfig )
                            {
//                                LED_CFG = 0;
                            }
                            else
                            {
//                                LED_CFG = 1;
                            }
                            break;
                        case USB_CLEAR_FEATURE:
                            if ( ( UsbSetupBuf->bRequestType & USB_REQ_RECIP_MASK ) == USB_REQ_RECIP_ENDP )// ˵
                            {
                                switch( UsbSetupBuf->wIndexL )
                                {
                                case 0x82:
                                    UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
                                    break;
                                case 0x02:
                                    UEP2_CTRL = UEP2_CTRL & ~ ( bUEP_R_TOG | MASK_UEP_R_RES ) | UEP_R_RES_ACK;
                                    break;
                                case 0x81:
                                    UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_T_TOG | MASK_UEP_T_RES ) | UEP_T_RES_NAK;
									if(CH375CSW) mCH375UpCsw();
									lastFSTALL=FSTALL;
									FSTALL=0;
                                    break;
                                case 0x01:
                                    UEP1_CTRL = UEP1_CTRL & ~ ( bUEP_R_TOG | MASK_UEP_R_RES ) | UEP_R_RES_ACK;						
									if(CH375CSW) mCH375UpCsw();
									lastFSTALL=FSTALL;
									FSTALL=0;
                                    break;
                                default:
                                    len = 0xFF;                                     // ֵ֧Ķ˵
                                    break;
                                }
                            }
                            else
                            {
                                len = 0xFF;                                         // Ƕ˵㲻֧
                            }
                            break;
                        case USB_GET_INTERFACE:
                            Ep0Buffer[0] = 0x00;
                            if ( SetupLen >= 1 )
                            {
                                len = 1;
                            }
                            break;
                        case USB_GET_STATUS:
                            Ep0Buffer[0] = 0x00;
                            Ep0Buffer[1] = 0x00;
                            if ( SetupLen >= 2 )
                            {
                                len = 2;
                            }
                            else
                            {
                                len = SetupLen;
                            }
                            break;
                        default:
                            len = 0xFF;                                             // ʧ
                            printf("ErrEp0ReqCode=%02X\n",(UINT16)SetupReqCode);
                            break;
                        }
                    }
                }
                else
                {
                    len = 0xFF;                                                    // SETUPȴ
                    printf("ErrEp0ReqSize\n");
                }
                if ( len == 0xFF )                                                 // ʧ
                {
                    SetupReqCode = 0xFF;
                    UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;// STALL
                }
                else if ( len <= THIS_ENDP0_SIZE )                                 // ϴݻ״̬׶η0Ȱ
                {
                    UEP0_T_LEN = len;
                    UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;// ĬݰDATA1
                }
                else                                                               // ´ݻ
                {
                    UEP0_T_LEN = 0;                                                // Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
                    UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;// ĬݰDATA1
                }
                break;
            case UIS_TOKEN_IN | 0:                                                 // endpoint 0# IN
                switch( SetupReqCode )
                {
                case USB_GET_DESCRIPTOR:
                    len = SetupLen >= THIS_ENDP0_SIZE ? THIS_ENDP0_SIZE : SetupLen; // δ䳤
                    memcpy( Ep0Buffer, pDescr, len );                               /* ϴ */
                    SetupLen -= len;
                    pDescr += len;
                    UEP0_T_LEN = len;
                    UEP0_CTRL ^= bUEP_T_TOG;                                        // ת
                    break;
                case USB_SET_ADDRESS:
                    USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
                    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                    break;
                default:
                    UEP0_T_LEN = 0;                                                 // ״̬׶жϻǿϴ0ݰƴ
                    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
                    break;
                }
                break;
            case UIS_TOKEN_OUT | 0:                                                 // endpoint 0# OUT
                switch( SetupReqCode )
                {
//                      case download:
//                          if ( U_TOG_OK ) {                                       // ͬݰ
//                              UEP0_CTRL ^= bUEP_R_TOG;                            // ת
//                              get_data;
//                              //UEP0_CTRL = UEP0_CTRL & bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;// Ԥϴ0ݰDATA1Էǰ״̬׶
//                          }
//                          break;
                case USB_GET_DESCRIPTOR:
                default:
                    if ( U_TOG_OK )                                                 // ͬݰ
                    {
//                              if ( USB_RX_LEN ) control_status_error;
//                              else control_ok;                                    // յ0Ȱʾƶ/ϴOK
                    }
//                          else control_status_error;
                    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;                      // ׼һƴ
                    break;
                }
                break;
            default:
                printf("ErrEndp INT\n");
                break;
            }
        }
        UIF_TRANSFER = 0;                                                           // жϱ־
    }
    else if ( UIF_BUS_RST )                                                         // USB߸λ
    {
		printf("Reset\n");
        UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
        UEP1_CTRL = bUEP_AUTO_TOG | UEP_R_RES_ACK | UEP_T_RES_NAK;
        USB_DEV_AD = 0x00;
        UIF_SUSPEND = 0;
        UIF_TRANSFER = 0;
        UIF_BUS_RST = 0;                                                            // жϱ־
    }
    else if ( UIF_SUSPEND )                                                         // USB߹/
    {
        UIF_SUSPEND = 0;
        if ( USB_MIS_ST & bUMS_SUSPEND )                                            // 
        {
            printf( "Suspend\n" );                                                        // ˯״̬
            while ( XBUS_AUX & bUART0_TX );                                         // ȴ
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            WAKE_CTRL = bWAK_BY_USB | bWAK_RXD0_LO;                                 // USBRXD0źʱɱ
            PCON |= PD;                                                             // ˯
            SAFE_MOD = 0x55;
            SAFE_MOD = 0xAA;
            WAKE_CTRL = 0x00;
        }
        else                                                                        // 
        {
            printf( "Awake\n" ); 
        }
    }
    else 
    {                                                                               // ж,ܷ
        printf("Unknown INT\n");
        USB_INT_FG = 0xFF;                                                          // жϱ־
    }
	
}
